/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:11:58 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:anglejog:Jog two axes (or joints) at an angle\n\nThis component accepts a dynamic counts-in input (typically from a\nmanual pulse generator (MPG)) and static angle and scale factor\nsettings.  It computes the counts and scale values required to jog two\n(M,N) axes (or joints) at an angle.  The corresponding output pins\nmust be connected to the candidate axis.[MN].jog* (or joint.[MN].jog*)\npins to create motion at the current angle.  Hal pins are provided to\nset the vector velocity and acceleration and to enable the\ncomputations.\n\nNotes:\n\n1. The max-vel, max-accel settings should be \\fBless than or\nequal\\fR to the smallest settings for both of the target axes.\n\n2. The scale-in pin is sampled only when the enable-in pin\nis false.  The value in use is output on the current-scale pin.\n\n3. The angle-degrees-in pin is sampled only when the enable-in\npin is false.  The value in use is output on the current-angle-degrees\npin.\n\n4. The value of the iscale-factor pin multiplies counts-in internally\nto support integer (s32) calculations for counting.  The current-scale-out\nis divided by the same amount.  The pin is sampled only when the\nenable-in pin is false.  The default value should work in most\napplications.\n\n5. For identity kins machines that support both world jogging (axis letter)\nand joint jogging (joint number), connections are needed for both the\naxis pins: axis.[MN].jog-enable,jog-scale,jog-counts and the corresponding\njoint pins: joint.[mn].jog-enable,jog-scale,jog-counts where [mn] are\nthe joint numbers corresponding to the [MN] axis letters.\n6. The current-scale pin is for information, the required output scaling\npin is current-scale-out as it depends on the iscale-factor setting.\n\n\\fBSimulation Config\\fR: configs/sim/axis/anglejog/anglejog.in\n");
MODULE_INFO(linuxcnc, "pin:enable_in:bit:0:in:enables motion (disables alteration of angle and scale):None:None");
MODULE_INFO(linuxcnc, "pin:counts_in:s32:0:in:MPG (wheel) counts:None:None");
MODULE_INFO(linuxcnc, "pin:angle_degrees_in:float:0:in:vector angle:None:None");
MODULE_INFO(linuxcnc, "pin:iscale_factor:s32:0:in:integer scaling factor (>1):10000:None");
MODULE_INFO(linuxcnc, "pin:scale_in:float:0:in:magnitude units/count (mag = counts * scale):None:None");
MODULE_INFO(linuxcnc, "pin:max_vel:float:0:in:vector max velocity magnitude:None:None");
MODULE_INFO(linuxcnc, "pin:max_accel:float:0:in:vector max acceleration magnitude:None:None");
MODULE_INFO(linuxcnc, "pin:accel_fraction_in:float:0:in:acceleration fraction input:1:None");
MODULE_INFO(linuxcnc, "pin:enable_out:bit:0:out:to: axis.M.jog-enable AND axis.N.jog-enable:None:None");
MODULE_INFO(linuxcnc, "pin:current_scale:float:0:out:effective scale (informational):None:None");
MODULE_INFO(linuxcnc, "pin:current_scale_out:float:0:out:to: axis.M.jog-scale AND axis.N.jog-scale:None:None");
MODULE_INFO(linuxcnc, "pin:coscounts:s32:0:out:to: axis.M.jog-counts (cosine counts):None:None");
MODULE_INFO(linuxcnc, "pin:sincounts:s32:0:out:to: axis.N.jog-counts (sine   counts):None:None");
MODULE_INFO(linuxcnc, "pin:cos_accel_fraction:float:0:out:to: axis.M.jog-accel-fraction:None:None");
MODULE_INFO(linuxcnc, "pin:sin_accel_fraction:float:0:out:to: axis.N.jog-accel-fraction:None:None");
MODULE_INFO(linuxcnc, "pin:active:bit:0:out:angle jog move in progress:None:None");
MODULE_INFO(linuxcnc, "pin:current_angle_degrees:float:0:out:current angle:None:None");
MODULE_INFO(linuxcnc, "pin:current_mag:float:0:out:current vector magnitude:None:None");
MODULE_INFO(linuxcnc, "pin:current_vel:float:0:out:current vector speed:None:None");
MODULE_INFO(linuxcnc, "funct:_:1:");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:Dewey Garrett");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_bit_t *enable_in;
    hal_s32_t *counts_in;
    hal_float_t *angle_degrees_in;
    hal_s32_t *iscale_factor;
    hal_float_t *scale_in;
    hal_float_t *max_vel;
    hal_float_t *max_accel;
    hal_float_t *accel_fraction_in;
    hal_bit_t *enable_out;
    hal_float_t *current_scale;
    hal_float_t *current_scale_out;
    hal_s32_t *coscounts;
    hal_s32_t *sincounts;
    hal_float_t *cos_accel_fraction;
    hal_float_t *sin_accel_fraction;
    hal_bit_t *active;
    hal_float_t *current_angle_degrees;
    hal_float_t *current_mag;
    hal_float_t *current_vel;
};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_bit_newf(HAL_IN, &(inst->enable_in), comp_id,
        "%s.enable-in", prefix);
    if(r != 0) return r;
    r = hal_pin_s32_newf(HAL_IN, &(inst->counts_in), comp_id,
        "%s.counts-in", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->angle_degrees_in), comp_id,
        "%s.angle-degrees-in", prefix);
    if(r != 0) return r;
    r = hal_pin_s32_newf(HAL_IN, &(inst->iscale_factor), comp_id,
        "%s.iscale-factor", prefix);
    if(r != 0) return r;
    *(inst->iscale_factor) = 10000;
    r = hal_pin_float_newf(HAL_IN, &(inst->scale_in), comp_id,
        "%s.scale-in", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->max_vel), comp_id,
        "%s.max-vel", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->max_accel), comp_id,
        "%s.max-accel", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->accel_fraction_in), comp_id,
        "%s.accel-fraction-in", prefix);
    if(r != 0) return r;
    *(inst->accel_fraction_in) = 1;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->enable_out), comp_id,
        "%s.enable-out", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->current_scale), comp_id,
        "%s.current-scale", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->current_scale_out), comp_id,
        "%s.current-scale-out", prefix);
    if(r != 0) return r;
    r = hal_pin_s32_newf(HAL_OUT, &(inst->coscounts), comp_id,
        "%s.coscounts", prefix);
    if(r != 0) return r;
    r = hal_pin_s32_newf(HAL_OUT, &(inst->sincounts), comp_id,
        "%s.sincounts", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->cos_accel_fraction), comp_id,
        "%s.cos-accel-fraction", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->sin_accel_fraction), comp_id,
        "%s.sin-accel-fraction", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->active), comp_id,
        "%s.active", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->current_angle_degrees), comp_id,
        "%s.current-angle-degrees", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->current_mag), comp_id,
        "%s.current-mag", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->current_vel), comp_id,
        "%s.current-vel", prefix);
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of anglejog");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of anglejog");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("anglejog");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "anglejog.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef enable_in
#define enable_in (0+*__comp_inst->enable_in)
#undef counts_in
#define counts_in (0+*__comp_inst->counts_in)
#undef angle_degrees_in
#define angle_degrees_in (0+*__comp_inst->angle_degrees_in)
#undef iscale_factor
#define iscale_factor (0+*__comp_inst->iscale_factor)
#undef scale_in
#define scale_in (0+*__comp_inst->scale_in)
#undef max_vel
#define max_vel (0+*__comp_inst->max_vel)
#undef max_accel
#define max_accel (0+*__comp_inst->max_accel)
#undef accel_fraction_in
#define accel_fraction_in (0+*__comp_inst->accel_fraction_in)
#undef enable_out
#define enable_out (*__comp_inst->enable_out)
#undef current_scale
#define current_scale (*__comp_inst->current_scale)
#undef current_scale_out
#define current_scale_out (*__comp_inst->current_scale_out)
#undef coscounts
#define coscounts (*__comp_inst->coscounts)
#undef sincounts
#define sincounts (*__comp_inst->sincounts)
#undef cos_accel_fraction
#define cos_accel_fraction (*__comp_inst->cos_accel_fraction)
#undef sin_accel_fraction
#define sin_accel_fraction (*__comp_inst->sin_accel_fraction)
#undef active
#define active (*__comp_inst->active)
#undef current_angle_degrees
#define current_angle_degrees (*__comp_inst->current_angle_degrees)
#undef current_mag
#define current_mag (*__comp_inst->current_mag)
#undef current_vel
#define current_vel (*__comp_inst->current_vel)


#line 64 "hal/components/anglejog.comp"
#include "rtapi_math.h"
#define TO_RAD M_PI/180
// replicate simple_tp.h define for tiny magnitude delta:
#define TINY_DP(max_accel,period) (max_accel*period*period*0.001)
#define MIN_ISCALE_FACTOR     10
#define MAX_ISCALE_FACTOR 100000

FUNCTION(_) {
static bool once = 1;
static bool wait_for_count_change = 0;
static int  tot_counts;
static int  old_enable_in;
static int  old_counts_in;
static int  ifactor = 0;
    double  max_dv, tiny_dp, mag_err, vel_req;
    double  mag_cmd;
    int     delta_counts = 0;
    int     newcounts;

    if (once) {
        current_angle_degrees = angle_degrees_in;
        current_scale     = scale_in;
        current_scale_out = scale_in/iscale_factor;
        ifactor = iscale_factor;
        once = 0;
    }

    newcounts = ifactor*counts_in;
    if (enable_in && !old_enable_in) { // enabling
        newcounts = ifactor*counts_in;
        old_counts_in = newcounts;
        wait_for_count_change = 1;
        tot_counts = current_mag/current_scale_out;
    }
    delta_counts  = newcounts - old_counts_in;
    old_enable_in = enable_in;
    old_counts_in = newcounts;
    enable_out    = enable_in;

    if (delta_counts!=0) {wait_for_count_change = 0;}
    if (enable_in) { tot_counts = tot_counts + delta_counts;}
    mag_cmd = tot_counts * current_scale_out;

    active = 0;
    /* compute max change in velocity per servo period */
    max_dv = max_accel * fperiod;
    /* compute a tiny magnitude range, to be treated as zero */
    tiny_dp = TINY_DP(max_accel, fperiod);
    /* calculate desired velocity */
    if (enable_in && !wait_for_count_change) {
        /* planner enabled, request a velocity that tends to drive
           mag_err to zero, but allows for stopping without magnitude
           overshoot */
        mag_err = mag_cmd - current_mag;
        /* positive and negative errors require some sign flipping to
           avoid sqrt(negative) */
        if (mag_err > tiny_dp) {
            vel_req = -max_dv +
                       sqrt(2.0 * max_accel * mag_err + max_dv * max_dv);
            /* mark planner as active */
            active = 1;
        } else if (mag_err < -tiny_dp) {
            vel_req =  max_dv -
                       sqrt(-2.0 * max_accel * mag_err + max_dv * max_dv);
            /* mark planner as active */
            active = 1;
        } else {
            /* within 'tiny_dp' of desired mag, no need to move */
            vel_req = 0.0;
        }
    } else {
        /* planner disabled or wait_for_count_change, request zero velocity */
        vel_req = 0.0;
        /* and set command to present magnitude to avoid movement when
           next enabled */
        mag_cmd = current_mag;
        //NOTE: changes allowed only when disabled:
        if (!enable_in) {
            static bool gave_msg = 0;
            bool new_ifactor = 0;
            if (ifactor != iscale_factor) {
                if (   iscale_factor >= MIN_ISCALE_FACTOR
                    && iscale_factor <= MAX_ISCALE_FACTOR) {
                    ifactor = iscale_factor;
                    rtapi_print("new ifactor=%d\n",ifactor);
                    new_ifactor = 1;
                    gave_msg = 0;
                } else {
                    if (!gave_msg) {
                        rtapi_print("BOGUS iscale_factor=%d (min=%d max=%d)\n"
                        ,ifactor,MIN_ISCALE_FACTOR,MAX_ISCALE_FACTOR);
                        gave_msg = 1;
                    }
                }
            }
            current_angle_degrees = angle_degrees_in;
            if (   current_scale_out != scale_in
                || new_ifactor) {
                current_scale      = scale_in;
                current_scale_out  = scale_in/ifactor;
                tot_counts = current_mag/current_scale_out;
            }
        }
        if (wait_for_count_change) return;
    }
    /* limit velocity request */
    if (vel_req > max_vel) {
        vel_req = max_vel;
    } else if (vel_req < -max_vel) {
        vel_req = -max_vel;
    }
    /* ramp velocity toward request at accel limit */
    if (vel_req > current_vel + max_dv) {
        current_vel += max_dv;
    } else if (vel_req < current_vel - max_dv) {
        current_vel -= max_dv;
    } else {
        current_vel = vel_req;
    }
    /* check for still moving */
    if (current_vel != 0.0) {
        /* yes, mark planner active */
        active = 1;
    }
    /* integrate velocity to get new magnitude */
    current_mag += current_vel * fperiod;
    double cos_angle,sin_angle;
    cos_angle = cos(current_angle_degrees * TO_RAD);
    sin_angle = sin(current_angle_degrees * TO_RAD);
    coscounts = current_mag * cos_angle/current_scale_out;
    sincounts = current_mag * sin_angle/current_scale_out;
    cos_accel_fraction = accel_fraction_in * cos_angle;
    sin_accel_fraction = accel_fraction_in * sin_angle;
}

static int __comp_get_data_size(void) { return 0; }
