/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:11:59 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:biquad:Biquad IIR filter");
MODULE_INFO(linuxcnc, "descr:Biquad IIR filter. Implements the following transfer function:\nH(z) = (n0 + n1z-1 + n2z-2) / (1+ d1z-1 + d2z-2)");
MODULE_INFO(linuxcnc, "pin:in:float:0:in:Filter input.:None:None");
MODULE_INFO(linuxcnc, "pin:out:float:0:out:Filter output.:None:None");
MODULE_INFO(linuxcnc, "pin:enable:bit:0:in:Filter enable. When false, the \\fBin\\fR pin is passed to the \\fBout\\fR pin without any filtering.  A \\fBtransition from false to true\\fR causes filter coefficients to be calculated according to the current \\fBtype\\fR and the describing pin and parameter settings:0:None");
MODULE_INFO(linuxcnc, "pin:valid:bit:0:out:When false, indicates an error occurred when calculating filter coefficients (require 2>\\fBQ\\fR>0.5 and \\fBf0\\fR>sampleRate/2):0:None");
MODULE_INFO(linuxcnc, "pin:type_:u32:0:in:Filter type determines the type of filter coefficients calculated.  When 0, coefficients must be loaded directly from the \\fBn0,n1,n2,d1\\fR params.  When 1, a low pass filter is created specified by the \\fBf0,Q\\fR pins.  When 2, a notch filter is created specified by the \\fBf0,Q\\fR pins.:0:None");
MODULE_INFO(linuxcnc, "pin:f0:float:0:in:The corner frequency of the filter.:250.0:None");
MODULE_INFO(linuxcnc, "pin:Q:float:0:in:The Q of the filter.:0.7071:None");
MODULE_INFO(linuxcnc, "param:d1:float:0:rw:1st-delayed denominator coef:0.0:None");
MODULE_INFO(linuxcnc, "param:d2:float:0:rw:2nd-delayed denominator coef:0.0:None");
MODULE_INFO(linuxcnc, "param:n0:float:0:rw:non-delayed numerator coef:1.0:None");
MODULE_INFO(linuxcnc, "param:n1:float:0:rw:1st-delayed numerator coef:0.0:None");
MODULE_INFO(linuxcnc, "param:n2:float:0:rw:2nd-delayed numerator coef:0.0:None");
MODULE_INFO(linuxcnc, "pin:s1:float:0:out:1st-delayed internal state (for debug only):0.0:None");
MODULE_INFO(linuxcnc, "pin:s2:float:0:out:2nd-delayed internal state (for debug only):0.0:None");
MODULE_INFO(linuxcnc, "funct:_:1:");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:Peter G. Vavaroutsos");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_float_t *in;
    hal_float_t *out;
    hal_bit_t *enable;
    hal_bit_t *valid;
    hal_u32_t *type_;
    hal_float_t *f0;
    hal_float_t *Q;
    hal_float_t *s1;
    hal_float_t *s2;
    hal_float_t d1;
    hal_float_t d2;
    hal_float_t n0;
    hal_float_t n1;
    hal_float_t n2;
    void *_data;
};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    inst->_data = (char*)inst + sizeof(struct __comp_state);
    r = extra_setup(inst, prefix, extra_arg);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->in), comp_id,
        "%s.in", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->out), comp_id,
        "%s.out", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IN, &(inst->enable), comp_id,
        "%s.enable", prefix);
    if(r != 0) return r;
    *(inst->enable) = 0;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->valid), comp_id,
        "%s.valid", prefix);
    if(r != 0) return r;
    *(inst->valid) = 0;
    r = hal_pin_u32_newf(HAL_IN, &(inst->type_), comp_id,
        "%s.type", prefix);
    if(r != 0) return r;
    *(inst->type_) = 0;
    r = hal_pin_float_newf(HAL_IN, &(inst->f0), comp_id,
        "%s.f0", prefix);
    if(r != 0) return r;
    *(inst->f0) = 250.0;
    r = hal_pin_float_newf(HAL_IN, &(inst->Q), comp_id,
        "%s.Q", prefix);
    if(r != 0) return r;
    *(inst->Q) = 0.7071;
    r = hal_pin_float_newf(HAL_OUT, &(inst->s1), comp_id,
        "%s.s1", prefix);
    if(r != 0) return r;
    *(inst->s1) = 0.0;
    r = hal_pin_float_newf(HAL_OUT, &(inst->s2), comp_id,
        "%s.s2", prefix);
    if(r != 0) return r;
    *(inst->s2) = 0.0;
    r = hal_param_float_newf(HAL_RW, &(inst->d1), comp_id,
        "%s.d1", prefix);
    inst->d1 = 0.0;
    if(r != 0) return r;
    r = hal_param_float_newf(HAL_RW, &(inst->d2), comp_id,
        "%s.d2", prefix);
    inst->d2 = 0.0;
    if(r != 0) return r;
    r = hal_param_float_newf(HAL_RW, &(inst->n0), comp_id,
        "%s.n0", prefix);
    inst->n0 = 1.0;
    if(r != 0) return r;
    r = hal_param_float_newf(HAL_RW, &(inst->n1), comp_id,
        "%s.n1", prefix);
    inst->n1 = 0.0;
    if(r != 0) return r;
    r = hal_param_float_newf(HAL_RW, &(inst->n2), comp_id,
        "%s.n2", prefix);
    inst->n2 = 0.0;
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of biquad");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of biquad");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("biquad");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "biquad.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in
#define in (0+*__comp_inst->in)
#undef out
#define out (*__comp_inst->out)
#undef enable
#define enable (0+*__comp_inst->enable)
#undef valid
#define valid (*__comp_inst->valid)
#undef type_
#define type_ (0+*__comp_inst->type_)
#undef f0
#define f0 (0+*__comp_inst->f0)
#undef Q
#define Q (0+*__comp_inst->Q)
#undef s1
#define s1 (*__comp_inst->s1)
#undef s2
#define s2 (*__comp_inst->s2)
#undef d1
#define d1 (__comp_inst->d1)
#undef d2
#define d2 (__comp_inst->d2)
#undef n0
#define n0 (__comp_inst->n0)
#undef n1
#define n1 (__comp_inst->n1)
#undef n2
#define n2 (__comp_inst->n2)
#undef data
#define data (*(Internal*)(__comp_inst->_data))


#line 75 "hal/components/biquad.comp"


#include <float.h>
#include <rtapi_math.h>


#define PI                      3.141592653589


void                            Biquad_CalcCoeffs(unsigned long period);


typedef enum {
    TYPE_DIRECT,
    TYPE_LOW_PASS,
    TYPE_NOTCH,
} Type;


typedef struct {
    hal_bit_t                   lastEnable;
} Internal;


EXTRA_SETUP()
{
    data.lastEnable = 0;

    return(0);
}


FUNCTION(_)
{
    if(data.lastEnable != enable){
        data.lastEnable = enable;

        if(enable) do {
                double sampleRate, w0, alpha;
                double b0, b1, b2, a0, a1, a2;

                // If not direct coefficient loading.
                if(type_ != TYPE_DIRECT){
                    valid = 0;

                    sampleRate = 1.0 / (period * 1e-9);

                    if((f0 > sampleRate / 2.0) || (Q > 2.0) || (Q < 0.5))
                        break;

                    w0 = 2.0 * PI * f0 / sampleRate;
                    alpha = sin(w0) / (2.0 * Q);

                    if(type_ == TYPE_LOW_PASS){
                        b0 = (1.0 - cos(w0)) / 2.0;
                        b1 = 1.0 - cos(w0);
                        b2 = (1.0 - cos(w0)) / 2.0;
                        a0 = 1.0 + alpha;
                        a1 = -2.0 * cos(w0);
                        a2 = 1.0 - alpha;
                    }else if(type_ == TYPE_NOTCH){
                        b0 = 1.0;
                        b1 = -2.0 * cos(w0);
                        b2 = 1.0;
                        a0 = 1.0 + alpha;
                        a1 = -2.0 * cos(w0);
                        a2 = 1.0 - alpha;
                    }else{
                        break;
                    }

                    n0 = b0 / a0;
                    n1 = b1 / a0;
                    n2 = b2 / a0;
                    d1 = a1 / a0;
                    d2 = a2 / a0;
                    s1 = s2 = 0.0;
                }

                valid = 1;
            } while(0);
    }

    if(!enable || !valid){
        out = in;
    }else{
        // Transposed direct form II.
        out = in * n0 + s1;
        s1 = in * n1 - out * d1 + s2;
        s2 = in * n2 - out * d2;
    }
}


static int __comp_get_data_size(void) { return sizeof(Internal); }
