/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:11:59 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:charge_pump:Create a square-wave for the 'charge pump' input of some controller boards");
MODULE_INFO(linuxcnc, "pin:out:bit:0:out:Square wave if 'enable' is TRUE or unconnected, low if 'enable' is FALSE:None:None");
MODULE_INFO(linuxcnc, "pin:out-2:bit:0:out:Square wave at half the frequency of 'out':None:None");
MODULE_INFO(linuxcnc, "pin:out-4:bit:0:out:Square wave at a quarter of the frequency of 'out':None:None");
MODULE_INFO(linuxcnc, "pin:enable:bit:0:in:If FALSE, forces all 'out' pins to be low:TRUE:None");
MODULE_INFO(linuxcnc, "funct:_:0:Toggle the output bit (if enabled)");
MODULE_INFO(linuxcnc, "descr:\nThe 'Charge Pump' should be added to the base thread function.\nWhen enabled the output is on for one period and off for one period. To calculate the\nfrequency of the output 1/(period time in seconds x 2) = Hz. For example if you\nhave a base period of 100,000ns that is 0.0001 seconds and the formula would be\n1/(0.0001 x 2) = 5,000 Hz or 5 kHz. Two additional outputs are provided that run\na factor of 2 and 4 slower for hardware that requires a lower frequency.");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:Jeff Epler");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_bit_t *out;
    hal_bit_t *out_2;
    hal_bit_t *out_4;
    hal_bit_t *enable;
};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_bit_newf(HAL_OUT, &(inst->out), comp_id,
        "%s.out", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->out_2), comp_id,
        "%s.out-2", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->out_4), comp_id,
        "%s.out-4", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IN, &(inst->enable), comp_id,
        "%s.enable", prefix);
    if(r != 0) return r;
    *(inst->enable) = TRUE;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 0, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
int rtapi_app_main(void) {
    int r = 0;
    comp_id = hal_init("charge_pump");
    if(comp_id < 0) return comp_id;
    r = export("charge-pump", 0);
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef out
#define out (*__comp_inst->out)
#undef out_2
#define out_2 (*__comp_inst->out_2)
#undef out_4
#define out_4 (*__comp_inst->out_4)
#undef enable
#define enable (0+*__comp_inst->enable)


#line 35 "hal/components/charge_pump.comp"
FUNCTION(_) {
    static int acc;
    if ( enable ) {
        acc++;
        out = (acc & 0x1);
        out_2 = (acc & 0x2);
        out_4 = (acc & 0x4);
    } else {
	out = 0;
	out_2 = 0;
	out_4 = 0;
    }
}

static int __comp_get_data_size(void) { return 0; }
