/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:11:59 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:comp:Two input comparator with hysteresis");
MODULE_INFO(linuxcnc, "pin:in0:float:0:in:Inverting input to the comparator:None:None");
MODULE_INFO(linuxcnc, "pin:in1:float:0:in:Non-inverting input to the comparator:None:None");
MODULE_INFO(linuxcnc, "pin:out:bit:0:out:Normal output. True when \\fBin1\\fR > \\fBin0\\fR (see parameter \\fBhyst\\fR for details):None:None");
MODULE_INFO(linuxcnc, "pin:equal:bit:0:out:Match output.  True when difference between \\fBin1\\fR and \\fBin0\\fR is less than \\fBhyst\\fR/2:None:None");
MODULE_INFO(linuxcnc, "param:hyst:float:0:rw:Hysteresis of the comparator (default 0.0)\n\nWith zero hysteresis, the output is true when \\fBin1\\fR > \\fBin0\\fR.  With nonzero\nhysteresis, the output switches on and off at two different values,\nseparated by distance \\fBhyst\\fR around the point where \\fBin1\\fR = \\fBin0\\fR.\nKeep in mind that floating point calculations are never absolute\nand it is wise to always set \\fBhyst\\fR if you intend to use equal :0.0:None");
MODULE_INFO(linuxcnc, "funct:_:1:Update the comparator");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:Jeff Epler");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_float_t *in0;
    hal_float_t *in1;
    hal_bit_t *out;
    hal_bit_t *equal;
    hal_float_t hyst;
};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_float_newf(HAL_IN, &(inst->in0), comp_id,
        "%s.in0", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->in1), comp_id,
        "%s.in1", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->out), comp_id,
        "%s.out", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->equal), comp_id,
        "%s.equal", prefix);
    if(r != 0) return r;
    r = hal_param_float_newf(HAL_RW, &(inst->hyst), comp_id,
        "%s.hyst", prefix);
    inst->hyst = 0.0;
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of comp");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of comp");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("comp");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "comp.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in0
#define in0 (0+*__comp_inst->in0)
#undef in1
#define in1 (0+*__comp_inst->in1)
#undef out
#define out (*__comp_inst->out)
#undef equal
#define equal (*__comp_inst->equal)
#undef hyst
#define hyst (__comp_inst->hyst)


#line 19 "hal/components/comp.comp"
FUNCTION(_) {
    double tmp = in1 - in0;
    double halfhyst = 0.5 * hyst;

    if(tmp < -halfhyst) {
	out = 0;
	equal = 0;
    } else if(tmp > halfhyst){
	out = 1;
	equal = 0;
    } else {
	equal = 1;
    }
}

static int __comp_get_data_size(void) { return 0; }
