/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:11:59 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:corexy_by_hal:CoreXY kinematics");
MODULE_INFO(linuxcnc, "pin:alpha_fb:float:0:in:typ: feedback from alpha motor controller:None:None");
MODULE_INFO(linuxcnc, "pin:beta_fb:float:0:in:typ: feedback from beta  motor controller:None:None");
MODULE_INFO(linuxcnc, "pin:j0_motor_pos_cmd:float:0:in:typ: from joint.0.motor-pos-cmd:None:None");
MODULE_INFO(linuxcnc, "pin:j1_motor_pos_cmd:float:0:in:typ: from joint.1.motor-pos-cmd:None:None");
MODULE_INFO(linuxcnc, "pin:j0_motor_pos_fb:float:0:out:typ: to joint.0.motor-pos-fb:None:None");
MODULE_INFO(linuxcnc, "pin:j1_motor_pos_fb:float:0:out:typ: to joint.1.motor-pos-fb:None:None");
MODULE_INFO(linuxcnc, "pin:alpha_cmd:float:0:out:typ: command to alpha motor:None:None");
MODULE_INFO(linuxcnc, "pin:beta_cmd:float:0:out:typ: command to beta ts motor:None:None");
MODULE_INFO(linuxcnc, "funct:_:1:");
MODULE_INFO(linuxcnc, "descr:\nImplement \\fBCoreXY\\fR forward and inverse transformations\n\\fBin HAL\\fR.  This component provides an alternative\nmethod for implementing \\fBCoreXY\\fR kinematics.\n\nIn the INI file, use:\n\n\\fB[KINS]KINEMATICS=trivkins coordinates=xyz kinstype=both\\fR\n\nThis component accepts two joint (\\fBj0,j1\\fR) motor\nposition commands for a trivkins coordinates=xyz configuration\nand computes equivalent \\fBCoreXY\\fR motor commands for\ntwo motors identified as \\fBalpha,beta\\fR.  Similarly,\nthe component accepts feedback values for the\n\\fBalpha,beta\\fR motor controllers and converts to\nequivalent joint (\\fBj0,j1\\fR) motor position feedback values.\n\nNotes:\n\n1) Using \\fBtrivkins\\fR with this module allows home switches\nto trigger according to the \\fBCartesian x,y\\fR positions\n\n2) Joint pin names are based on \\fBcoordinates=xyz\\fR and\nthe corresponding joint number assignments used by\n\\fBtrivkins\\fR so \\fBj0==x, j1==y\\fR\n(man trivkins for more information)\n\n3) \\fBCoreXY\\fR kinematics can also be implemented using\nthe kinematics module named \\fBcorexykins\\fR with home\nswitches triggered by the \\fB j0,j1 motor\\fR positions.\n(man kins for more information)\n");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:Dewey Garrett based on forum post from nbremond");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_float_t *alpha_fb;
    hal_float_t *beta_fb;
    hal_float_t *j0_motor_pos_cmd;
    hal_float_t *j1_motor_pos_cmd;
    hal_float_t *j0_motor_pos_fb;
    hal_float_t *j1_motor_pos_fb;
    hal_float_t *alpha_cmd;
    hal_float_t *beta_cmd;
};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_float_newf(HAL_IN, &(inst->alpha_fb), comp_id,
        "%s.alpha-fb", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->beta_fb), comp_id,
        "%s.beta-fb", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->j0_motor_pos_cmd), comp_id,
        "%s.j0-motor-pos-cmd", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->j1_motor_pos_cmd), comp_id,
        "%s.j1-motor-pos-cmd", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->j0_motor_pos_fb), comp_id,
        "%s.j0-motor-pos-fb", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->j1_motor_pos_fb), comp_id,
        "%s.j1-motor-pos-fb", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->alpha_cmd), comp_id,
        "%s.alpha-cmd", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->beta_cmd), comp_id,
        "%s.beta-cmd", prefix);
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of corexy_by_hal");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of corexy_by_hal");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("corexy_by_hal");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "corexy-by-hal.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef alpha_fb
#define alpha_fb (0+*__comp_inst->alpha_fb)
#undef beta_fb
#define beta_fb (0+*__comp_inst->beta_fb)
#undef j0_motor_pos_cmd
#define j0_motor_pos_cmd (0+*__comp_inst->j0_motor_pos_cmd)
#undef j1_motor_pos_cmd
#define j1_motor_pos_cmd (0+*__comp_inst->j1_motor_pos_cmd)
#undef j0_motor_pos_fb
#define j0_motor_pos_fb (*__comp_inst->j0_motor_pos_fb)
#undef j1_motor_pos_fb
#define j1_motor_pos_fb (*__comp_inst->j1_motor_pos_fb)
#undef alpha_cmd
#define alpha_cmd (*__comp_inst->alpha_cmd)
#undef beta_cmd
#define beta_cmd (*__comp_inst->beta_cmd)


#line 53 "hal/components/corexy_by_hal.comp"

FUNCTION(_) {

    // forward kinematics (j0==x,j1==y from motor positions):
    j0_motor_pos_fb = alpha_fb + beta_fb;
    j1_motor_pos_fb = alpha_fb - beta_fb;

    // inverse kinematics (motor positions from j0==x,j1==y):
    alpha_cmd = 0.5*(j0_motor_pos_cmd + j1_motor_pos_cmd);
    beta_cmd  = 0.5*(j0_motor_pos_cmd - j1_motor_pos_cmd);
}

static int __comp_get_data_size(void) { return 0; }
