/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:11:59 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:edge:Edge detector");
MODULE_INFO(linuxcnc, "pin:in:bit:0:in::None:None");
MODULE_INFO(linuxcnc, "pin:out:bit:0:out:Goes high when the desired edge is seen on 'in':None:None");
MODULE_INFO(linuxcnc, "pin:out_invert:bit:0:out:Goes low when the desired edge is seen on 'in':None:None");
MODULE_INFO(linuxcnc, "param:both:bit:0:rw:If TRUE, selects both edges.  Otherwise, selects one edge according to in-edge:FALSE:None");
MODULE_INFO(linuxcnc, "param:in_edge:bit:0:rw:If both is FALSE, selects the one desired edge: TRUE means falling, FALSE means rising:TRUE:None");
MODULE_INFO(linuxcnc, "param:out_width_ns:s32:0:rw:Time in nanoseconds of the output pulse:0:None");
MODULE_INFO(linuxcnc, "param:time_left_ns:s32:0:r:Time left in this output pulse:None:None");
MODULE_INFO(linuxcnc, "param:last_in:bit:0:r:Previous input value:None:None");
MODULE_INFO(linuxcnc, "funct:_:0:Produce output pulses from input edges");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:Jeff Epler");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_bit_t *in;
    hal_bit_t *out;
    hal_bit_t *out_invert;
    hal_bit_t both;
    hal_bit_t in_edge;
    hal_s32_t out_width_ns;
    hal_s32_t time_left_ns;
    hal_bit_t last_in;
    int first;

};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_bit_newf(HAL_IN, &(inst->in), comp_id,
        "%s.in", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->out), comp_id,
        "%s.out", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->out_invert), comp_id,
        "%s.out-invert", prefix);
    if(r != 0) return r;
    r = hal_param_bit_newf(HAL_RW, &(inst->both), comp_id,
        "%s.both", prefix);
    inst->both = FALSE;
    if(r != 0) return r;
    r = hal_param_bit_newf(HAL_RW, &(inst->in_edge), comp_id,
        "%s.in-edge", prefix);
    inst->in_edge = TRUE;
    if(r != 0) return r;
    r = hal_param_s32_newf(HAL_RW, &(inst->out_width_ns), comp_id,
        "%s.out-width-ns", prefix);
    inst->out_width_ns = 0;
    if(r != 0) return r;
    r = hal_param_s32_newf(HAL_RO, &(inst->time_left_ns), comp_id,
        "%s.time-left-ns", prefix);
    if(r != 0) return r;
    r = hal_param_bit_newf(HAL_RO, &(inst->last_in), comp_id,
        "%s.last-in", prefix);
    if(r != 0) return r;
    inst->first = 1.0;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 0, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of edge");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of edge");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("edge");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "edge.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in
#define in (0+*__comp_inst->in)
#undef out
#define out (*__comp_inst->out)
#undef out_invert
#define out_invert (*__comp_inst->out_invert)
#undef both
#define both (__comp_inst->both)
#undef in_edge
#define in_edge (__comp_inst->in_edge)
#undef out_width_ns
#define out_width_ns (__comp_inst->out_width_ns)
#undef time_left_ns
#define time_left_ns (__comp_inst->time_left_ns)
#undef last_in
#define last_in (__comp_inst->last_in)
#undef first
#define first (__comp_inst->first)


#line 35 "hal/components/edge.comp"

FUNCTION(_){ 
    int new_in = in;
    if (time_left_ns > 0) {
        time_left_ns -= period;
    }
    if ( !first ) {
        int rise = new_in && !last_in;
        int fall = !new_in && last_in;
        int desired_edge =
            both ? rise || fall
                    : in_edge ? fall : rise;
        if(desired_edge) {
            time_left_ns = out_width_ns;
            out = 1;
        } else if(time_left_ns > 0) {
            out = 1;
        } else {
            time_left_ns = 0;
            out = 0;
        }
    } else {
        first = 0;
    }
    last_in = new_in;
    out_invert = !out;
}


static int __comp_get_data_size(void) { return 0; }
