/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:11:59 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:estop_latch:Software ESTOP latch");
MODULE_INFO(linuxcnc, "descr:\nThis component can be used as a part of a simple software ESTOP chain.\n\nIt has two states: \"OK\" and \"Faulted\".\n\nThe initial state is \"Faulted\".  When faulted, the\n.B out-ok\noutput is false,\nthe\n.B fault-out\noutput is true, and the\n.B watchdog\noutput is unchanging.\n\nThe state changes from \"Faulted\" to \"OK\" when\n.B all\nthese conditions are true:\n.RS\n.IP \\(bu\n.B fault-in\nis false\n.IP \\(bu\n.B ok-in\nis true\n.IP \\(bu\n.B reset\nchanges from false to true\n.RE\n\nWhen \"OK\", the\n.B out-ok\noutput is true, the\n.B fault-out\noutput is false, and the\n.B watchdog\noutput is toggling.\n\nThe state changes from \"OK\" to \"Faulted\" when\n.B any\nof the following are true:\n.RS\n.IP \\(bu\n.B fault-in\nis true\n.IP \\(bu\n.B ok-in\nis false\n.RE\n\nTo facilitate using only a single fault source,\n.B ok-in\nand\n.B fault-en\nare both set to the non-fault-causing value when no signal is connected.\nFor estop-latch to ever be able to signal a fault, at least one of these\ninputs must be connected.\n\nTypically, an external fault or estop input is connected to \\fBfault-in\\fR,\n\\fBiocontrol.0.user-request-enable\\fR is connected to \\fBreset\\fR,\nand \\fBok-out\\fR is connected to \\fBiocontrol.0.emc-enable-in\\fB.\n\nIn more complex systems, it may be more appropriate to use classicladder to\nmanage the software portion of the estop chain.\n");
MODULE_INFO(linuxcnc, "pin:ok_in:bit:0:in::true:None");
MODULE_INFO(linuxcnc, "pin:fault_in:bit:0:in::false:None");
MODULE_INFO(linuxcnc, "pin:reset:bit:0:in::None:None");
MODULE_INFO(linuxcnc, "pin:ok_out:bit:0:out::false:None");
MODULE_INFO(linuxcnc, "pin:fault_out:bit:0:out::true:None");
MODULE_INFO(linuxcnc, "pin:watchdog:bit:0:out::None:None");
MODULE_INFO(linuxcnc, "funct:_:0:");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:John Kasunich");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_bit_t *ok_in;
    hal_bit_t *fault_in;
    hal_bit_t *reset;
    hal_bit_t *ok_out;
    hal_bit_t *fault_out;
    hal_bit_t *watchdog;
    void *_data;
};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    inst->_data = (char*)inst + sizeof(struct __comp_state);
    r = hal_pin_bit_newf(HAL_IN, &(inst->ok_in), comp_id,
        "%s.ok-in", prefix);
    if(r != 0) return r;
    *(inst->ok_in) = true;
    r = hal_pin_bit_newf(HAL_IN, &(inst->fault_in), comp_id,
        "%s.fault-in", prefix);
    if(r != 0) return r;
    *(inst->fault_in) = false;
    r = hal_pin_bit_newf(HAL_IN, &(inst->reset), comp_id,
        "%s.reset", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->ok_out), comp_id,
        "%s.ok-out", prefix);
    if(r != 0) return r;
    *(inst->ok_out) = false;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->fault_out), comp_id,
        "%s.fault-out", prefix);
    if(r != 0) return r;
    *(inst->fault_out) = true;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->watchdog), comp_id,
        "%s.watchdog", prefix);
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 0, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of estop_latch");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of estop_latch");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("estop_latch");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "estop-latch.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef ok_in
#define ok_in (0+*__comp_inst->ok_in)
#undef fault_in
#define fault_in (0+*__comp_inst->fault_in)
#undef reset
#define reset (0+*__comp_inst->reset)
#undef ok_out
#define ok_out (*__comp_inst->ok_out)
#undef fault_out
#define fault_out (*__comp_inst->fault_out)
#undef watchdog
#define watchdog (*__comp_inst->watchdog)
#undef data
#define data (*(estop_data*)(__comp_inst->_data))


#line 79 "hal/components/estop_latch.comp"

typedef struct { int old_reset; } estop_data;

FUNCTION(_) {
    /* check inputs */
    if ( ok_in && !fault_in) {
	/* no fault conditions, check for reset edge */
	if ( reset && !data.old_reset ) {
	    /* got a rising edge, indicate "OK" on outputs */
	    ok_out = 1;
	    fault_out = 0;
	}
	if( ok_out ) {
	    /* toggle watchdog */
	    watchdog = !watchdog;
	}
    } else {
	/* fault condition exists, trip */
	ok_out = 0;
	fault_out = 1;
    }
    /* store state of reset input for next pass (for edge detect) */
    data.old_reset = reset;
}

static int __comp_get_data_size(void) { return sizeof(estop_data); }
