/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:11:59 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:ilowpass:Low-pass filter with integer inputs and outputs");
MODULE_INFO(linuxcnc, "descr:While it may find other applications, this component was written\nto create smoother motion while jogging with an MPG.\n\nIn a machine with high acceleration, a short jog can behave almost like a step\nfunction.  By putting the \\fBilowpass\\fR component between the MPG\nencoder \\fBcounts\\fR output and the axis \\fRjog-counts\\fR input,\nthis can be smoothed.\n\nChoose \\fBscale\\fR conservatively so that during a single session\nthere will never be more than about 2e9/\\fBscale\\fR pulses seen\non the MPG.  Choose \\fBgain\\fR according to the smoothing level\ndesired.  Divide the \\fRaxis.\\fIN\\fR.jog-scale\\fR values by\n\\fBscale\\fR.");
MODULE_INFO(linuxcnc, "pin:in:s32:0:in::None:None");
MODULE_INFO(linuxcnc, "pin:out:s32:0:out:\\fBout\\fR tracks \\fBin\\fR*\\fBscale\\fR through a low-pass\nfilter of \\fBgain\\fR per period.:None:None");
MODULE_INFO(linuxcnc, "param:scale:float:0:rw:A scale factor applied to the output\nvalue of the low-pass filter.:1024:None");
MODULE_INFO(linuxcnc, "param:gain:float:0:rw:Together with the period, sets the rate at\nwhich the output changes.  Useful range is between 0 and 1, with higher\nvalues causing the input value to be tracked more quickly.  For\ninstance, a setting of 0.9 causes the output value to go 90% of the way\ntowards the input value in each period.:.5:None");
MODULE_INFO(linuxcnc, "funct:_:1:Update the output based on the input and parameters.");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:Jeff Epler");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_s32_t *in;
    hal_s32_t *out;
    hal_float_t scale;
    hal_float_t gain;
    double value;

};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_s32_newf(HAL_IN, &(inst->in), comp_id,
        "%s.in", prefix);
    if(r != 0) return r;
    r = hal_pin_s32_newf(HAL_OUT, &(inst->out), comp_id,
        "%s.out", prefix);
    if(r != 0) return r;
    r = hal_param_float_newf(HAL_RW, &(inst->scale), comp_id,
        "%s.scale", prefix);
    inst->scale = 1024;
    if(r != 0) return r;
    r = hal_param_float_newf(HAL_RW, &(inst->gain), comp_id,
        "%s.gain", prefix);
    inst->gain = .5;
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of ilowpass");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of ilowpass");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("ilowpass");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "ilowpass.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in
#define in (0+*__comp_inst->in)
#undef out
#define out (*__comp_inst->out)
#undef scale
#define scale (__comp_inst->scale)
#undef gain
#define gain (__comp_inst->gain)
#undef value
#define value (__comp_inst->value)


#line 37 "hal/components/ilowpass.comp"
#include <rtapi_math.h>

FUNCTION(_) {
    value += (in - value) * gain;
    out = (int)(rtapi_s64)floor((value * scale) + 0.5);
}

static int __comp_get_data_size(void) { return 0; }
