/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:11:59 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:limit_axis:Dynamic range based axis limits");
MODULE_INFO(linuxcnc, "descr:limit_axis.c\n\nLimit axis to certain limits at varying inputs\nFor example on a spindle with C rotation, to avoid hitting a\ngantry when the height is above Z-10\n - Use Z axis as feedback\n - Use 2 ranges (0,-10) (-10, -40)\n - When Z is above 10, C rotation is limited to range 0\n - When Z is below 10, C rotation is limited to range 1\n\n Usage:\n loadrt limit_axis count=3 personality=2,3,2\n or\n loadrt limit_axis names=limit_x,limit_y,limit_z personality=2,3,2\n\n The \"personality\" argument defines how many ranges are supported by each instance.\n (Note that no spaces can be used in the names= and personality= parameters)\n\n Caveats\n - Searches ranges from 0 to 9 and will take the first range that matches\n - Ranges are inclusive min_range <= feedback <= max_range\n - Max can not be less than minimum for any group\n - Sticky indicates, to not check other ranges if the feedback is still in the current range\n - Enable allows for a range to be turned on/off, for cases such as avoiding a tool changer, but allowing sometimes");
MODULE_INFO(linuxcnc, "author:Chad Woitas");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "funct:_:1:");
MODULE_INFO(linuxcnc, "pin:error-no-range:bit:0:out:error pin indicating that no range matches the fb:None:None");
MODULE_INFO(linuxcnc, "pin:min-output:float:0:out:Minimum limit output:None:None");
MODULE_INFO(linuxcnc, "pin:max-output:float:0:out:Maximum limit output:None:None");
MODULE_INFO(linuxcnc, "pin:fb:float:0:in:Feedback pin, the value of this pin determines which range is active:None:None");
MODULE_INFO(linuxcnc, "pin:current-range:u32:0:out:Indicates which range is currently active:None:None");
MODULE_INFO(linuxcnc, "pin:min-limit-##:float:(10, 'personality'):in:The array of minimum limits to select from:None:None");
MODULE_INFO(linuxcnc, "pin:max-limit-##:float:(10, 'personality'):in:The array of macimum limits:None:None");
MODULE_INFO(linuxcnc, "pin:min-range-##:float:(10, 'personality'):in:Defines the range of values with which the fb is compared to set the range:None:None");
MODULE_INFO(linuxcnc, "pin:max-range-##:float:(10, 'personality'):in:Defines the range of values with which the fb is compared to set the range:None:None");
MODULE_INFO(linuxcnc, "pin:enable-##:bit:(10, 'personality'):in:Used to enable and disable a specific range:None:None");
MODULE_INFO(linuxcnc, "pin:sticky-##:bit:(10, 'personality'):in:Used to make specific range 'sticky' or not:None:None");
MODULE_INFO(linuxcnc, "pin:error-range-##:bit:(10, 'personality'):out:Error bit indicating that the fb pin falls outside all ranges:1:None");
MODULE_INFO(linuxcnc, "pin:error-limit-##:bit:(10, 'personality'):out:Error bit indicating that the max limit is not larger than the min limit:1:None");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    int _personality;
    hal_bit_t *error_no_range;
    hal_float_t *min_output;
    hal_float_t *max_output;
    hal_float_t *fb;
    hal_u32_t *current_range;
    hal_float_t *min_limit[10];
    hal_float_t *max_limit[10];
    hal_float_t *min_range[10];
    hal_float_t *max_range[10];
    hal_bit_t *enable[10];
    hal_bit_t *sticky[10];
    hal_bit_t *error_range[10];
    hal_bit_t *error_limit[10];
};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg, long personality) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    inst->_personality = personality;
    r = extra_setup(inst, prefix, extra_arg);
    if(r != 0) return r;
    personality = inst->_personality;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->error_no_range), comp_id,
        "%s.error-no-range", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->min_output), comp_id,
        "%s.min-output", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->max_output), comp_id,
        "%s.max-output", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_IN, &(inst->fb), comp_id,
        "%s.fb", prefix);
    if(r != 0) return r;
    r = hal_pin_u32_newf(HAL_OUT, &(inst->current_range), comp_id,
        "%s.current-range", prefix);
    if(r != 0) return r;
    if((personality) > (10)) {
        rtapi_print_msg(RTAPI_MSG_ERR,"Pin min-limit-##: Requested size %d exceeds max size %d\n",(int)personality, (int)10);
        return -ENOSPC;
    }
    for(j=0; j < (personality); j++) {
        r = hal_pin_float_newf(HAL_IN, &(inst->min_limit[j]), comp_id,
            "%s.min-limit-%02d", prefix, j);
        if(r != 0) return r;
    }
    if((personality) > (10)) {
        rtapi_print_msg(RTAPI_MSG_ERR,"Pin max-limit-##: Requested size %d exceeds max size %d\n",(int)personality, (int)10);
        return -ENOSPC;
    }
    for(j=0; j < (personality); j++) {
        r = hal_pin_float_newf(HAL_IN, &(inst->max_limit[j]), comp_id,
            "%s.max-limit-%02d", prefix, j);
        if(r != 0) return r;
    }
    if((personality) > (10)) {
        rtapi_print_msg(RTAPI_MSG_ERR,"Pin min-range-##: Requested size %d exceeds max size %d\n",(int)personality, (int)10);
        return -ENOSPC;
    }
    for(j=0; j < (personality); j++) {
        r = hal_pin_float_newf(HAL_IN, &(inst->min_range[j]), comp_id,
            "%s.min-range-%02d", prefix, j);
        if(r != 0) return r;
    }
    if((personality) > (10)) {
        rtapi_print_msg(RTAPI_MSG_ERR,"Pin max-range-##: Requested size %d exceeds max size %d\n",(int)personality, (int)10);
        return -ENOSPC;
    }
    for(j=0; j < (personality); j++) {
        r = hal_pin_float_newf(HAL_IN, &(inst->max_range[j]), comp_id,
            "%s.max-range-%02d", prefix, j);
        if(r != 0) return r;
    }
    if((personality) > (10)) {
        rtapi_print_msg(RTAPI_MSG_ERR,"Pin enable-##: Requested size %d exceeds max size %d\n",(int)personality, (int)10);
        return -ENOSPC;
    }
    for(j=0; j < (personality); j++) {
        r = hal_pin_bit_newf(HAL_IN, &(inst->enable[j]), comp_id,
            "%s.enable-%02d", prefix, j);
        if(r != 0) return r;
    }
    if((personality) > (10)) {
        rtapi_print_msg(RTAPI_MSG_ERR,"Pin sticky-##: Requested size %d exceeds max size %d\n",(int)personality, (int)10);
        return -ENOSPC;
    }
    for(j=0; j < (personality); j++) {
        r = hal_pin_bit_newf(HAL_IN, &(inst->sticky[j]), comp_id,
            "%s.sticky-%02d", prefix, j);
        if(r != 0) return r;
    }
    if((personality) > (10)) {
        rtapi_print_msg(RTAPI_MSG_ERR,"Pin error-range-##: Requested size %d exceeds max size %d\n",(int)personality, (int)10);
        return -ENOSPC;
    }
    for(j=0; j < (personality); j++) {
        r = hal_pin_bit_newf(HAL_OUT, &(inst->error_range[j]), comp_id,
            "%s.error-range-%02d", prefix, j);
        if(r != 0) return r;
    *(inst->error_range[j]) = 1;
    }
    if((personality) > (10)) {
        rtapi_print_msg(RTAPI_MSG_ERR,"Pin error-limit-##: Requested size %d exceeds max size %d\n",(int)personality, (int)10);
        return -ENOSPC;
    }
    for(j=0; j < (personality); j++) {
        r = hal_pin_bit_newf(HAL_OUT, &(inst->error_limit[j]), comp_id,
            "%s.error-limit-%02d", prefix, j);
        if(r != 0) return r;
    *(inst->error_limit[j]) = 1;
    }
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of limit_axis");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of limit_axis");
static int personality[64] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
RTAPI_MP_ARRAY_INT(personality, 64, "personality of each limit_axis");

            static int p_value(char* cname, char *name, int idx) {
                int ans = personality[idx%64];
                if (idx >= 64) {
            

                    if (name==NULL) {
                        rtapi_print_msg(RTAPI_MSG_ERR,"%s: instance %d assigned personality=%d(=%#0x)\n",
                                        cname, idx, ans, ans);
                    } else {
                        rtapi_print_msg(RTAPI_MSG_ERR,"%s: name %s assigned personality=%d(=%#0x)\n",
                                        cname, name, ans, ans);
                    }
                }
                return ans;
            }
            
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("limit_axis");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "limit-axis.%d", i);
            r = export(buf, i, p_value("limit_axis", buf, i) );
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx, p_value("limit_axis", buf, idx) );
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef error_no_range
#define error_no_range (*__comp_inst->error_no_range)
#undef min_output
#define min_output (*__comp_inst->min_output)
#undef max_output
#define max_output (*__comp_inst->max_output)
#undef fb
#define fb (0+*__comp_inst->fb)
#undef current_range
#define current_range (*__comp_inst->current_range)
#undef min_limit
#define min_limit(i) (0+*(__comp_inst->min_limit[i]))
#undef max_limit
#define max_limit(i) (0+*(__comp_inst->max_limit[i]))
#undef min_range
#define min_range(i) (0+*(__comp_inst->min_range[i]))
#undef max_range
#define max_range(i) (0+*(__comp_inst->max_range[i]))
#undef enable
#define enable(i) (0+*(__comp_inst->enable[i]))
#undef sticky
#define sticky(i) (0+*(__comp_inst->sticky[i]))
#undef error_range
#define error_range(i) (*(__comp_inst->error_range[i]))
#undef error_limit
#define error_limit(i) (*(__comp_inst->error_limit[i]))
#undef personality
#define personality (__comp_inst->_personality)


#line 50 "hal/components/limit_axis.comp"

FUNCTION(_){
  int i;
  // Check sticky bit
  if(sticky(current_range)){
    if (min_range(current_range) <= fb &&
        fb <= max_range(current_range) &&
        enable(current_range)) {

      max_output = max_limit(current_range);
      min_output = min_limit(current_range);

      return;
    }
  }

  // Check all ranges
  for (i = 0; i < personality; i++){
    if (max_range(i) < min_range(i)){
      if(! enable(i)){
        continue;
      }

      // Throw Error and skip this range
      if (! error_range(i) ){
        rtapi_print_msg(RTAPI_MSG_ERR,
                        "limit_axis: Error in range %d settings! Min: %f > Max: %f \n",
                        i,
                        max_range(i),
                        min_range(i));
        error_range(i) = 1;
      }
      continue;
    }
    // If we made it to here clear the error
    error_range(i) = 0;

    if (max_limit(i) < min_limit(i)){
      // Throw Error and skip this range
      if (! error_limit(i)){
        rtapi_print_msg(RTAPI_MSG_ERR,
                        "limit_axis: Error in limit %d settings! Min: %f > Max: %f \n",
                        i,
                        max_limit(i),
                        min_limit(i));
        error_limit(i) = 1;
      }
      continue;
    }
    // If we made it to here clear the error
    error_limit(i) = 0;

    // Check position, take first range that it fits in.
    if(min_range(i) <= fb && fb <= max_range(i)) {
      max_output = max_limit(i);
      min_output = min_limit(i);
      // Found our limits, stop looking
      error_no_range = 0;
      if (i != current_range){
        rtapi_print_msg(RTAPI_MSG_INFO, "limit_axis: Switching to Range %d\n", i);
        current_range = i;
      }
      return;
    }
  }

  // If we've looked through all our ranges, then it's not there
  if (!error_no_range){
    error_no_range = 1;
    rtapi_print_msg(RTAPI_MSG_ERR,
                    "limit_axis: No Range found corresponding to feedback");

  }

}

EXTRA_SETUP(){
    if (personality > 10) personality = 10;
    if (personality < 2) personality = 2;
    return 0;
}

static int __comp_get_data_size(void) { return 0; }
