/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:11:59 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:message:Display a message");
MODULE_INFO(linuxcnc, "descr:Allows HAL pins to trigger a message. Example hal commands:\n loadrt message names=oillow,oilpressure,inverterfail messages=\"Slideway oil low,No oil\npressure,Spindle inverter fault\"\n addf oillow servo-thread\n addf oilpressure servo-thread\n addf inverterfail servo-thread\n \n setp oillow.edge 0 #this pin should be active low\n net no-oil classicladder.0.out-21 oillow.trigger\n net no-pressure classicladder.0.out-22 oilpressure.trigger\n net no-inverter classicladder.0.out-23 inverterfail.trigger\n \nWhen any pin goes active, the corresponding message will be displayed.");
MODULE_INFO(linuxcnc, "pin:trigger:bit:0:in:signal that triggers the message:FALSE:None");
MODULE_INFO(linuxcnc, "pin:force:bit:0:in:A FALSE->TRUE transition forces the message to be\ndisplayed again if the trigger is active:FALSE:None");
MODULE_INFO(linuxcnc, "param:edge:bit:0:rw:Selects the desired edge: FALSE means falling, TRUE\nmeans rising:TRUE:None");
MODULE_INFO(linuxcnc, "funct:_:0:Display a message");
MODULE_INFO(linuxcnc, "license:GPL v2");
MODULE_INFO(linuxcnc, "author:Les Newell");
MODULE_LICENSE("GPL v2");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_bit_t *trigger;
    hal_bit_t *force;
    hal_bit_t edge;
    int myidx;

    hal_bit_t prev_trigger;

    hal_bit_t prev_force;

    hal_bit_t prev_edge;

};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = extra_setup(inst, prefix, extra_arg);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IN, &(inst->trigger), comp_id,
        "%s.trigger", prefix);
    if(r != 0) return r;
    *(inst->trigger) = FALSE;
    r = hal_pin_bit_newf(HAL_IN, &(inst->force), comp_id,
        "%s.force", prefix);
    if(r != 0) return r;
    *(inst->force) = FALSE;
    r = hal_param_bit_newf(HAL_RW, &(inst->edge), comp_id,
        "%s.edge", prefix);
    inst->edge = TRUE;
    if(r != 0) return r;
    inst->prev_trigger = 0;
    inst->prev_force = 1;
    inst->prev_edge = 1;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 0, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of message");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of message");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("message");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "message.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef trigger
#define trigger (0+*__comp_inst->trigger)
#undef force
#define force (0+*__comp_inst->force)
#undef edge
#define edge (__comp_inst->edge)
#undef myidx
#define myidx (__comp_inst->myidx)
#undef prev_trigger
#define prev_trigger (__comp_inst->prev_trigger)
#undef prev_force
#define prev_force (__comp_inst->prev_force)
#undef prev_edge
#define prev_edge (__comp_inst->prev_edge)


#line 79 "hal/components/message.comp"
 
char *messages[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
RTAPI_MP_ARRAY_STRING(messages, 16, "Displayed strings");
 
FUNCTION(_){
    hal_bit_t show = false;    
    if(!!prev_edge != !!edge) /* edge type has changed */
    {
        prev_edge = edge;
        prev_trigger = !edge;
    }
    if(!!force != !!prev_force) /* force type has changed */
    {
        prev_force = force;
        if(force && (!!trigger == !!edge))
        {
            show = true;
        }
    }
    if(!!trigger != !!prev_trigger) /* trigger has changed */
    {
        prev_trigger = trigger;
        if(!!trigger == !!edge)
        {
            show = true;
        }
    }
    if(show && (messages[myidx] != 0))
    {
        rtapi_print_msg(RTAPI_MSG_ERR, "%s\n", messages[myidx]);
    }
}
 
EXTRA_SETUP(){
    myidx = extra_arg;
    if(myidx<0 || myidx >15)
    {
        rtapi_print_msg(RTAPI_MSG_ERR,"Count of names= is outside the allowable range 0..15\n");
        return -EINVAL;
    }
    if(messages[myidx] == 0)
    {
        rtapi_print_msg(RTAPI_MSG_ERR,"Message string for index %d missing\n", myidx);
        return -EINVAL;
    }
    return(0);
}

static int __comp_get_data_size(void) { return 0; }
