/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:11:59 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:updown:Counts up or down, with optional limits and wraparound behavior");
MODULE_INFO(linuxcnc, "pin:countup:bit:0:in:Increment count when this pin goes from 0 to 1:None:None");
MODULE_INFO(linuxcnc, "pin:countdown:bit:0:in:Decrement count when this pin goes from 0 to 1:None:None");
MODULE_INFO(linuxcnc, "pin:reset:bit:0:in:Reset count when this pin goes from 0 to 1:None:None");
MODULE_INFO(linuxcnc, "pin:count:s32:0:out:The current count:None:None");
MODULE_INFO(linuxcnc, "param:clamp:bit:0:rw:If TRUE, then clamp the output to the min and max parameters.:None:None");
MODULE_INFO(linuxcnc, "param:wrap:bit:0:rw:If TRUE, then wrap around when the count goes above or below the min and max parameters.  Note that wrap implies (and overrides) clamp.:None:None");
MODULE_INFO(linuxcnc, "param:max:s32:0:rw:If clamp or wrap is set, count will never exceed this number:0x7FFFFFFF:None");
MODULE_INFO(linuxcnc, "param:min:s32:0:rw:If clamp or wrap is set, count will never be less than this number:None:None");
MODULE_INFO(linuxcnc, "funct:_:0:Process inputs and update count if necessary");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:Stephen Wille Padnos");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_bit_t *countup;
    hal_bit_t *countdown;
    hal_bit_t *reset;
    hal_s32_t *count;
    hal_bit_t clamp;
    hal_bit_t wrap;
    hal_s32_t max;
    hal_s32_t min;
    int oldup;

    int olddown;

    int first;

};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_bit_newf(HAL_IN, &(inst->countup), comp_id,
        "%s.countup", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IN, &(inst->countdown), comp_id,
        "%s.countdown", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IN, &(inst->reset), comp_id,
        "%s.reset", prefix);
    if(r != 0) return r;
    r = hal_pin_s32_newf(HAL_OUT, &(inst->count), comp_id,
        "%s.count", prefix);
    if(r != 0) return r;
    r = hal_param_bit_newf(HAL_RW, &(inst->clamp), comp_id,
        "%s.clamp", prefix);
    if(r != 0) return r;
    r = hal_param_bit_newf(HAL_RW, &(inst->wrap), comp_id,
        "%s.wrap", prefix);
    if(r != 0) return r;
    r = hal_param_s32_newf(HAL_RW, &(inst->max), comp_id,
        "%s.max", prefix);
    inst->max = 0x7FFFFFFF;
    if(r != 0) return r;
    r = hal_param_s32_newf(HAL_RW, &(inst->min), comp_id,
        "%s.min", prefix);
    if(r != 0) return r;
    inst->first = 1.0;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 0, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of updown");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of updown");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("updown");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "updown.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef countup
#define countup (0+*__comp_inst->countup)
#undef countdown
#define countdown (0+*__comp_inst->countdown)
#undef reset
#define reset (0+*__comp_inst->reset)
#undef count
#define count (*__comp_inst->count)
#undef clamp
#define clamp (__comp_inst->clamp)
#undef wrap
#define wrap (__comp_inst->wrap)
#undef max
#define max (__comp_inst->max)
#undef min
#define min (__comp_inst->min)
#undef oldup
#define oldup (__comp_inst->oldup)
#undef olddown
#define olddown (__comp_inst->olddown)
#undef first
#define first (__comp_inst->first)


#line 18 "hal/components/updown.comp"

FUNCTION(_) {
	hal_s32_t temp_count = count;
	if (first) {
		oldup=countup;
		olddown=countdown;
		first=0;
	}
	if ((!oldup) && (countup)) { // positive edge, count up
		temp_count++;
	}
	if ((!olddown) && (countdown)) { // positive edge, count down
		temp_count--;
	}
	if (reset) {
		temp_count=0;
	}
	if (wrap) {
		if (temp_count > max)
			temp_count = min;
		else if (temp_count < min)
			temp_count = max;
	} else if (clamp) {
		if (temp_count > max)
			temp_count = max;
		else if (temp_count < min)
			temp_count = min;
	}
	count = temp_count;
	oldup = countup;
	olddown = countdown;
}

static int __comp_get_data_size(void) { return 0; }
