/* Autogenerated by ../bin/halcompile on Fri Apr 26 19:11:59 2024 -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "rtapi_math64.h"

static int comp_id;

#include <hostmot2-serial.h>
#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:mesa_uart:An example component demonstrating how to access the Hostmot2 UART");
MODULE_INFO(linuxcnc, "descr:This component creates 16 input and 16 output pins. It transmits \n{name}.N.tx-bytes on the selected UART every thread cycle and reads up to 16\nbytes each cycle out of the receive FIFO and writes the values to the associated\noutput pins. {name}.rx-bytes indicates how many pins have been written to. \n(pins > rx-bytes simply hold their previous value)\n\nThis module uses the names= mode of loadrt declaration to specify which UART \ninstances to enable. A check is included to ensure that the count= option is \nnot used instead.\n\nThe component takes parameters in the form of a comma-separated\nlist of UART instance names, for example:\n\n\\fB loadrt mesa_uart names=hm2_5i23.0.uart.0,hm2_5i23.0.uart.7\\fR\n\nNote that no spaces are allowed in the string unless it is delimited by double \nquotes. \n\nThe UART instance names are printed to the dmesg buffer during the Hostmot2 \nsetup sequence, one for each UART instance included in the bitfile loaded to \neach installed card during the Hostmot2 setup sequence. Type \"dmesg\" at the \nterminal prompt to view the output.\n\nThe component exports two functions, send and receive, which need to be added\nto a realtime thread.\n\nThe above example will output data on UART channels 0 and 7 and the pins will \nhave the names of the individual UARTS. (they need not be on the same card, or\neven the same bus).\n\nRead the documents on \"halcompile\" for help with writing realtime components:\nhttp://linuxcnc.org/docs/html/hal/comp.html");
MODULE_INFO(linuxcnc, "author:Andy Pugh andy@bodgesoc.org");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "pin:tx-data-##:u32:16:in:Data to be transmitted:None:None");
MODULE_INFO(linuxcnc, "pin:rx-data-##:u32:16:out:Data received:None:None");
MODULE_INFO(linuxcnc, "pin:tx-bytes:s32:0:in:Number of bytes to transmit:None:None");
MODULE_INFO(linuxcnc, "pin:rx-bytes:s32:0:out:Number of Bytes received:None:None");
MODULE_INFO(linuxcnc, "funct:send:1:");
MODULE_INFO(linuxcnc, "funct:receive:1:");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_u32_t *tx_data[16];
    hal_u32_t *rx_data[16];
    hal_s32_t *tx_bytes;
    hal_s32_t *rx_bytes;
    char *name;

};
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void send(struct __comp_state *__comp_inst, long period);
static void receive(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = extra_setup(inst, prefix, extra_arg);
    if(r != 0) return r;
    for(j=0; j < (16); j++) {
        r = hal_pin_u32_newf(HAL_IN, &(inst->tx_data[j]), comp_id,
            "%s.tx-data-%02d", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < (16); j++) {
        r = hal_pin_u32_newf(HAL_OUT, &(inst->rx_data[j]), comp_id,
            "%s.rx-data-%02d", prefix, j);
        if(r != 0) return r;
    }
    r = hal_pin_s32_newf(HAL_IN, &(inst->tx_bytes), comp_id,
        "%s.tx-bytes", prefix);
    if(r != 0) return r;
    r = hal_pin_s32_newf(HAL_OUT, &(inst->rx_bytes), comp_id,
        "%s.rx-bytes", prefix);
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s.send", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))send, inst, 1, 0, comp_id);
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s.receive", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))receive, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    return 0;
}
static int default_count=1, count=0;
RTAPI_MP_INT(count, "number of mesa_uart");
char *names = ""; // comma separated names
RTAPI_MP_STRING(names, "names of mesa_uart");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("mesa_uart");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "mesa-uart.%d", i);
            r = export(buf, i);
            if(r != 0) break;
       }
    } else {
        size_t i, j;
        int idx;
        char buf[HAL_NAME_LEN+1];
        const size_t length = strlen(names);
        for (i = j = idx = 0; i <= length; i++) {
            const char c = buf[j] = names[i];
            if ((c == ',') || (c == '\0')) {
                buf[j] = '\0';
                r = export(buf, idx);
                if(r != 0) {break;}
                idx++;
                j = 0;
            } else {
                if (++j == (sizeof(buf) / sizeof(buf[0]))) {
                    buf[j - 1] = '\0';
                    rtapi_print_msg(RTAPI_MSG_ERR,"names: \"%s\" too long\n", buf);
                    r = -EINVAL;
                    break;
                }
            }
        }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef tx_data
#define tx_data(i) (0+*(__comp_inst->tx_data[i]))
#undef rx_data
#define rx_data(i) (*(__comp_inst->rx_data[i]))
#undef tx_bytes
#define tx_bytes (0+*__comp_inst->tx_bytes)
#undef rx_bytes
#define rx_bytes (*__comp_inst->rx_bytes)
#undef name
#define name (__comp_inst->name)


#line 54 "hal/drivers/mesa_uart.comp"

/* This uses the RTAPI_MP_ARRAY_STRING macro to load the list of UART channels
into an array. This is copied into the *name string of each */

char *uart_chans[18] = {0,};
RTAPI_MP_ARRAY_STRING(uart_chans, 16, "UART Channel names");

FUNCTION(send){
/* This function uses the hm2_uart_send function to transmit data see 
man hm2_uart_send for more information. Data may be up to 64 bytes in size*/
    
    unsigned char data[16];
    int i, count;
    count = tx_bytes;
    if (count > 16) count = 16;
    for (i = 0 ; i < count ; i++){
        data[i] = tx_data(i) & 0x000000FF; //NB [] index for array and () for pin.
    }
    count = hm2_uart_send(name, data, count);
}

FUNCTION(receive){
/* This function uses the hm2_uart_send function to transmit data. 
 See man hm2_uart_send for more information. 16 bytes in the Rx buffer*/
    
    int i;
    unsigned char data[16];
    rx_bytes = hm2_uart_read(name, data);
    for (i = 0 ; i < rx_bytes ; i++){
         rx_data(i) = data[i];
    }
}
    
EXTRA_SETUP(){ // the names parameters are passed in 'prefix'. You just have to know that. 
    if (prefix[0] == 'm'){ // should be the 'h' of hm2_....
        rtapi_print_msg(0, "mesa_uart can not be loaded using the 'count' "
                        "parameter, see man mesa_uart for details\n");
        return -1;
    }
    name = hal_malloc(strlen(prefix)+1);
    strcpy(name, prefix);
    // 250000bps, no delay, tx enable)
    hm2_uart_setup(name, 250000, 0x40, -1);
    return 0;
}




int get_count(void){
    int i;
    for (i= 0; uart_chans[i] != NULL && i < 16 ; i++){}
    return i;
}

static int __comp_get_data_size(void) { return 0; }
